/**
 * \file 	search_on_fixed.h
 * \author 	Ioannis Koutras (joko@microlab.ntua.gr)
 * \date 	September, 2011
 *  
 * \brief Exact-fit search on fixed lists
 */

#ifndef SEARCH_ON_FIXED_H
#define SEARCH_ON_FIXED_H

#include <dmmlib/heap.h>

/**
 * Perform an exact-fit search on fixed lists for a block of a certain size
 *
 * \param heap The heap whose fixed lists should be accessed.
 * \param requested_size The desired size of the block.
 *
 * \return The pointer of the data part of the matched memory block.
 * \retval NULL No block was found.
 */
void * search_on_fixed(heap_t * heap, size_t requested_size);

#endif /* SEARCH_ON_FIXED_H */

