#include "sll/search_on_fixed.h"
#include "block_header.h"

/**
 * \details The maptable of the heap is being traversed sequentially while
 * searching for a size equal of the requested size. If one is found, then we
 * return the head of this list and set the next block as the new head.
 */
void * search_on_fixed(heap_t * heap, size_t requested_size) {
    maptable_node_t *node;
    void *ptr;

    node = heap->maptable_head;
    ptr = NULL;

    while(node) {
        if(node->size == requested_size) {
            ptr = node->fixed_list_head;
            if(ptr != NULL) {
                node->fixed_list_head = get_next(ptr);
            }
            break;
        }
        node = node->next;
    }

    return ptr;
}
